Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/tablecmds.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.2
diff -c -r1.1.1.3 -r1.1.1.3.2.2
*** src/backend/commands/tablecmds.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/commands/tablecmds.c	26 May 2009 10:29:59 -0000	1.1.1.3.2.2
***************
*** 2603,2608 ****
--- 3399,3428 ----
  		case AT_ColumnDefault:	/* ALTER COLUMN DEFAULT */
  			ATExecColumnDefault(rel, cmd->name, cmd->def);
  			break;
+ 		case AT_DropPartitionByName:	/* DROP partition(by name) of an existing table.*/
+ 			ATExecDropPartitionByName(tab, rel, (Partition *)cmd->def);
+ 			break;
+ 		case AT_DropPartitionByRange:	/* DROP partition(by range) of an existing table.*/
+ 			ATExecDropPartitionByRange(tab, rel, (Partition *)cmd->def);
+ 			break;
+ 		case AT_ExchangePartition:	/* Exchange partition with a table.*/
+ 			ATExecExchangePartition(tab, rel, (ExchangePartitionStmt *)cmd->def);
+ 			break;
+ 		case AT_RenamePartition:	/* Rename a partition.*/
+ 			ATExecRenamePartition(tab, rel, (RenamePartitionStmt *)cmd->def);
+ 			break;
+ 		case AT_UpdatePartition: /* Update Range partition.*/
+ 			ATExecUpdatePartition(tab, rel, (Partition *)cmd->def);
+ 			break;
+ 		case AT_UpdateHashPartition: /* Update Range partition.*/
+ 			ATExecUpdateHashPartition(tab, rel, (A_Const *)cmd->def);
+ 			break;
+ 		case AT_SplitPartition: /* Update Range partition.*/
+ 			ATExecSplitPartition(tab, rel, (SplitPartitionStmt *)cmd->def);
+ 			break;
+ 		case AT_MergePartition: /* Update Range partition.*/
+ 			ATExecMergePartition(tab, rel, (MergePartitionStmt *)cmd->def);
+ 			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
  			ATExecDropNotNull(rel, cmd->name);
  			break;
Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/tablecmds.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.2
diff -c -r1.1.1.3 -r1.1.1.3.2.2
*** src/backend/commands/tablecmds.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/commands/tablecmds.c	26 May 2009 10:29:59 -0000	1.1.1.3.2.2
***************
*** 4165,4170 ****
--- 8150,8159 ----
  	List	   *children;
  	ObjectAddress object;
  
+ 	/* Check if the column is part of any partition key. */
+ 	if( GetPartitionsCountAtt(RelationGetRelid(rel), get_attnum(RelationGetRelid(rel), colName)) > 0)
+ 		elog(ERROR, "Can not drop column '%s' as this is part of partition key of '%s' table.", colName, RelationGetRelationName(rel));
+ 
  	/* At top level, permission check was done in ATPrepCmd, else do it */
  	if (recursing)
  		ATSimplePermissions(rel, false);
***************
*** 5694,5699 ****
--- 9683,9692 ----
  	SysScanDesc scan;
  	HeapTuple	depTup;
  
+ 	/* Check if the column is part of any partition key. */
+ 	if( GetPartitionsCountAtt(RelationGetRelid(rel), get_attnum(RelationGetRelid(rel), colName)) > 0)
+ 		elog(ERROR, "Can not alter column '%s' as this is part of partition key of '%s' table.", colName, RelationGetRelationName(rel));
+ 
  	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
  
  	/* Look up the target column */
***************
*** 7951,7954 ****
--- 11944,12780 ----
  			cur_item = lnext(prev_item);
  		}
  	}
+ }
+ 
+ 
+ /* 
+  * ------------------------------------------------------------------------------
+  *	DefinePartitions
+  *	Create new partitions. They end up inheriting from the parent
+  *	relation.
+  *	Once they have been created, triggers need to be assigned to the parent to
+  *	provide the UPDATEs/INSERTs/DELETEs to percolate down to the children
+  * 	Callers expect this function to end with CommandCounterIncrement if it
+  * 	makes any changes.
+  * ------------------------------------------------------------------------------
+  */
+ void
+ DefinePartitions(CreateStmt *stmt, Oid parentRelId)
+ {
+ 	RangeVar 		inr;
+ 	Oid 			childOid;
+ 	PartitionAttrs	*partAttr;
+ 	int 			*partKeyOrder;
+ 	List			*partColumnList;
+ 	ListCell		*partColumn;
+ 	int 			count, i, j;
+ 	List			*columnList;
+ 	ListCell		*column;
+ 	StringInfo  	childTableName = makeStringInfo();
+ 	Oid				*partitionRelOids;
+ 	bool			partitionColumnMatch;
+ 	Relation    	rel;
+ 	StringInfo  	createTrigger = makeStringInfo();
+ 	List        	*query_list;
+ 	Node        	*parsetree;
+ 	StringInfo  	tableName = makeStringInfo();
+ 	Oid				result;
+ 	bool			isOverflowReq = false;
+ 
+ 	/* If no partitions are defined then return. */
+ 	if (stmt->partAttr == NULL) 
+ 		return;
+ 
+ 	isOverflowReq = ((PartitionAttrs *)stmt->partAttr)->hasOverflowPartition;
+ 	
+ 	partColumnList = ((PartitionAttrs *)(stmt->partAttr))->colName;
+ 
+ 	i = 0;
+ 	j = 0;
+ 	partitionColumnMatch = false;
+ 
+ 	Assert(IsA(stmt->partAttr, PartitionAttrs));
+ 
+ 	partAttr = (PartitionAttrs *)(stmt->partAttr);
+ 	/* To store the partition key order */
+ 	partKeyOrder = malloc(partColumnList->length * sizeof(int));
+ 	columnList 	= stmt->tableElts;
+ 
+ 	foreach(partColumn, partColumnList)
+ 	{
+ 		/* Get the name of partition key column. */
+ 		char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 		count = 0;
+ 
+ 		foreach(column, columnList)
+ 		{
+ 			ColumnDef *tmp = lfirst(column);
+ 			count++;
+ 			if(strcmp(tmp->colname, colName) == 0)
+ 			{
+ 				partKeyOrder[j++] = count;
+ 				partitionColumnMatch = true;
+ 				break;
+ 			}
+ 		}
+ 		if(partitionColumnMatch == false)
+ 			elog(ERROR, "'%s' attribute is not present in given table.", colName);
+ 	}
+ 
+ 	/*
+ 	 * All the partitions will inherit from the parent, set the parent in the
+ 	 * inhRelations structure
+ 	 */
+ 	inr = *stmt->relation;
+ 
+ 	/* 
+ 	 * Create the children tables. The parser has already made sure that we
+ 	 * have atleast one partition in the list
+ 	 */
+ 	if (partAttr->partFunc == PART_LIST || partAttr->partFunc == PART_RANGE)
+ 	{
+ 		List 		*partitionList = partAttr->partitions;
+ 		ListCell 	*temp_part; 
+ 		int			isSystemGeneratedName = 0;
+ 		int 		isUserGeneratedName = 0;
+ 		int			i = 0;
+ 		Relation 	tmpRel;
+ 		bool		flag = false;
+ 		IndexStmt  *statement;
+ 
+ 
+ 		Assert(list_length(partitionList) > 0);
+ 
+ 		if(isOverflowReq == true)
+ 		{
+ 			StringInfo	query = makeStringInfo();
+ 		    /* Get overflow partition. */
+     		appendStringInfo(tableName, "of_%s_%u", stmt->relation->relname, parentRelId);
+ 	    	result = RelnameGetRelid(tableName->data);
+ 	
+ 	    	if(result == InvalidOid)
+ 		    {
+     		    CreateStmt  *childStmt = (CreateStmt *)copyObject((void *)stmt);
+ 	
+     	    	childStmt->inhRelations = lappend(NULL, stmt->relation);
+ 	    	    childStmt->relation->relname = tableName->data;
+ 				childStmt->tableElts = NIL;
+ 
+ 				result = DefineRelation(childStmt, RELKIND_RELATION);
+ 
+ 	    	    if(InvalidOid == result)
+     	    	    elog(ERROR, "Could not create overflow partition.");
+ 	    	}
+ 	    	else
+ 		    {
+     		    elog(ERROR, "Overflow partition '%s' for partitioned table '%s' already exists.",
+         		        tableName->data, stmt->relation->relname);
+ 		    }
+ 			tmpRel = RelationIdGetRelation(result);
+ 			appendStringInfo(query, "CREATE INDEX of_index_%u ON %s (", result, RelationGetRelationName(tmpRel));
+ 			RelationClose(tmpRel);
+ 
+ 			foreach(partColumn, partColumnList)
+ 			{
+ 				/* Get the name of partition key column. */
+ 				char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 				
+ 				if(flag == true)
+ 					appendStringInfo(query, ", %s", colName);
+ 				else
+ 				{
+ 					appendStringInfo(query, "%s", colName);
+ 					flag = true;
+ 				}
+ 			}
+ 
+ 			appendStringInfo(query, ")");
+ 
+ 			query_list  = pg_parse_query(query->data);
+ 			parsetree = (Node *)lfirst(list_head(query_list));
+ 			statement = (IndexStmt *) parsetree;	
+ 
+ 			CheckRelationOwnership(statement->relation, true);
+ 
+ 			/* Run parse analysis ... */
+ 			statement = transformIndexStmt(statement, query->data);
+ 
+ 			/* ... and do it */
+ 			DefineIndex(statement->relation,     /* relation */
+ 						statement->idxname,      /* index name */
+ 						InvalidOid, /* no predefined OID */
+ 						statement->accessMethod, /* am name */
+ 						statement->tableSpace,
+ 						statement->indexParams,  /* parameters */
+ 						(Expr *)statement->whereClause,
+ 						statement->options,
+ 						statement->unique,
+ 						statement->primary,
+ 						statement->isconstraint,
+ 						false,      /* is_alter_table */
+ 						true,       /* check_rights */
+ 						false,      /* skip_build */
+ 						false,      /* quiet */
+ 						statement->concurrent);  /* concurrent */			
+ 	
+ 			/* To avoid tuple being updated by the current transaction, after the current scan started */
+ 			CommandCounterIncrement();
+ 		}
+ 
+ 		rel = RelationIdGetRelation(parentRelId);
+ 		resetStringInfo(createTrigger);
+ 		appendStringInfo(createTrigger, "CREATE TRIGGER partition_insert_%u BEFORE INSERT ON %s ", RelationGetRelid(rel), RelationGetRelationName(rel));
+ 		appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_insert_trigger();");
+ 		relation_close(rel, 0);
+ 
+ 		/* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+ 		query_list  = pg_parse_query(createTrigger->data);
+ 		parsetree = (Node *)lfirst(list_head(query_list));
+ 		CreateTrigger((CreateTrigStmt * )parsetree, 0, false);
+ 
+ 		/* To avoid tuple being updated by the current transaction, after the current scan started */
+ 		CommandCounterIncrement();
+ 	
+ 		/* Allocate the storage for number of partitions.*/
+ 		partitionRelOids = malloc(sizeof(Oid)*list_length(partitionList));
+ 
+ 		foreach(temp_part, partitionList)
+ 		{
+ 			Partition *temp_partition = lfirst(temp_part);
+ 
+ 			/* If partition name is not specified then generate one and apply. */
+ 			if(temp_partition->partName == NULL)
+ 			{
+ 
+ 				if(isUserGeneratedName == 1)
+ 					elog(ERROR, "Combination of user generated and system generated table names is not allowed.");				
+ 
+ 				isSystemGeneratedName = 1;
+ 				i++;
+ 
+ 				appendStringInfo(childTableName, "%s_%d", stmt->relation->relname, i);
+ 
+ 				temp_partition->partName = makeNode(RangeVar);	
+ 				temp_partition->partName->relname = childTableName->data;
+ 			}
+ 			else
+ 			{
+ 	            if(isSystemGeneratedName == 0)
+ 				{
+ 					isUserGeneratedName = 1;
+ 				}
+ 				else
+ 					elog(ERROR, "Combination of user generated and system generated table names is not allowed.");				
+ 			}
+     		
+ 			childOid = CreateInheritedTable(parentRelId, temp_partition->partName->relname, temp_partition->tablespacename);
+ 
+ 		    rel = RelationIdGetRelation(childOid);
+ 		    resetStringInfo(createTrigger);
+ 		    appendStringInfo(createTrigger, "CREATE TRIGGER partition_update_%u BEFORE UPDATE ON %s ", RelationGetRelid(rel), RelationGetRelationName(rel));
+ 		    appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_update_trigger ();");
+ 		    relation_close(rel, 0);
+ 
+ 		    /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+ 		    query_list  = pg_parse_query(createTrigger->data);
+ 		    parsetree = (Node *)lfirst(list_head(query_list));
+ 		    CreateTrigger((CreateTrigStmt * )parsetree, 0, false);
+ 
+ 			/* To avoid tuple being updated by the current transaction, after the current scan started */
+ 			CommandCounterIncrement();
+ 		
+ 			/* Store the Child table Oids for later use. */
+ 			partitionRelOids[i++] = childOid;
+ 		}
+         /*
+        	 * Make the changes carried out so far, visible
+          */
+         CreatePartitions(stmt, parentRelId, partitionRelOids);
+         CommandCounterIncrement();
+ 
+ 		/* Free the storage. */
+ 		free(partitionRelOids);		
+ 
+ 	}
+ 	else if(partAttr->partFunc == PART_HASH)
+ 	{
+ 
+ 		bool 		typbyval;
+ 	    Datum 		values[Natts_pg_partition];
+ 	    bool  		nulls [Natts_pg_partition];
+ 		int16		len, k;
+ 		Oid 		typ_oid;
+ 		Relation        r;
+ 		TupleDesc       tupDesc;
+ 		HeapTuple       tup;
+ 
+ 
+ 		if(partAttr->numberOfPartitions < 1)
+ 		{
+ 			elog(ERROR, "Atleast one partition is required to create partitioned-table.");
+ 		}
+ 
+ 		i = 0;
+ 		j = 0;
+ 			
+ 		/* Allocate the storage for number of partitions.*/
+ 		partitionRelOids = malloc(sizeof(Oid) * partAttr->numberOfPartitions);
+ 
+ 		for(i=0; i<partAttr->numberOfPartitions; i++)
+ 		{
+ 			/* Device the name of child table. */
+ 			resetStringInfo(childTableName);
+ 			appendStringInfo(childTableName, "%s_%d", stmt->relation->relname, i);
+ 
+ 			/* Use this name to create child table. */
+ 			childOid = CreateInheritedTable(parentRelId, childTableName->data, NULL);
+ 	
+ 			/* Apply the update trigger. */	
+ 			rel = RelationIdGetRelation(childOid);
+ 			resetStringInfo(createTrigger);
+ 			appendStringInfo(createTrigger, "CREATE TRIGGER partition_update_%u BEFORE UPDATE ON %s ",RelationGetRelid(rel), RelationGetRelationName(rel));
+ 			appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_update_trigger();");
+ 	
+ 	    	/* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+ 	    	query_list  = pg_parse_query(createTrigger->data);
+ 		    parsetree = (Node *)lfirst(list_head(query_list));
+     		CreateTrigger((CreateTrigStmt * )parsetree, 0, false);
+ 
+ 			/* To avoid tuple being updated by the current transaction, after the current scan started */
+ 			CommandCounterIncrement();
+ 
+             /* We can not create constraints for hash partitions directly. Instead, we will monitor inserts using insert triggers.*/
+             resetStringInfo(createTrigger);
+             appendStringInfo(createTrigger, "CREATE TRIGGER partition_constraints_%u BEFORE INSERT ON %s ",RelationGetRelid(rel), RelationGetRelationName(rel));
+             appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_constraints_hash();");
+             relation_close(rel, 0);
+ 
+             /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+             query_list  = pg_parse_query(createTrigger->data);
+             parsetree = (Node *)lfirst(list_head(query_list));
+             CreateTrigger((CreateTrigStmt * )parsetree, 0, false);
+ 
+ 			k = 1;
+ 
+ 			foreach(partColumn, partColumnList)
+ 			{
+ 				/* Get the name of partition key column. */
+ 				char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 
+ 				/* Get the attribute type. */
+ 				typ_oid = get_atttype(parentRelId, get_attnum(parentRelId, colName));
+ 			
+ 				/* Get the attribute length*/
+ 				get_typlenbyval(typ_oid, &len, &typbyval);
+ 
+ 				/* initialize nulls and values */
+ 			    for (j = 0; j < Natts_pg_partition; j++)
+ 				{
+ 					nulls[j] = false;
+ 					values[j] = (Datum) NULL;
+ 				}				
+ 
+ 			    values[Anum_pg_partition_minval     -1] = Int8GetDatum(NULL);
+ 				nulls[Anum_pg_partition_minval     -1] = true;
+ 		    	values[Anum_pg_partition_maxval     -1] = Int8GetDatum(NULL);
+ 				nulls[Anum_pg_partition_maxval     -1] = true;
+ 			    values[Anum_pg_partition_parentrelid -1]= ObjectIdGetDatum(parentRelId);
+ 			    values[Anum_pg_partition_partrelid  -1] = ObjectIdGetDatum(childOid);
+ 		    	values[Anum_pg_partition_parttype   -1] = Int8GetDatum(PART_HASH);
+ 			    values[Anum_pg_partition_partkey    -1] = ObjectIdGetDatum(get_attnum(parentRelId, colName));
+ 			    values[Anum_pg_partition_listval    -1] = Int8GetDatum(NULL);
+ 			    nulls[Anum_pg_partition_listval     -1] = true;
+ 		    	values[Anum_pg_partition_hashval    -1] = Int8GetDatum(i);
+ 			    values[Anum_pg_partition_keytype    -1] = ObjectIdGetDatum(typ_oid);
+ 				values[Anum_pg_partition_keyorder   -1] = Int8GetDatum(k);
+ 
+ 				k++;
+ 
+ 			    r = heap_open(PartitionRelationId, RowExclusiveLock);
+ 			    tupDesc = r->rd_att;
+ 	
+ 			    tup = heap_form_tuple(tupDesc, values, nulls);
+ 			    simple_heap_insert(r, tup);
+ 				CatalogUpdateIndexes(r, tup); 
+ 
+ 			    heap_close(r, RowExclusiveLock);
+ 			}
+ 		}
+ 
+ 		rel = RelationIdGetRelation(parentRelId);
+ 		resetStringInfo(createTrigger);
+ 		appendStringInfo(createTrigger, "CREATE TRIGGER partition_insert_%u BEFORE INSERT ON %s ", RelationGetRelid(rel), RelationGetRelationName(rel));
+ 		appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_insert_trigger_hash();");
+ 		relation_close(rel, 0);
+ 	
+ 	    /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+     	query_list  = pg_parse_query(createTrigger->data);
+ 	    parsetree = (Node *)lfirst(list_head(query_list));
+     	CreateTrigger((CreateTrigStmt * )parsetree, 0, false);
+ 
+         /*
+          * Make the changes carried out so far, visible
+          */
+         CreatePartitions(stmt, parentRelId, partitionRelOids);
+         CommandCounterIncrement();
+ 		
+ 		/* Free the storage. */
+ 		free(partitionRelOids);		
+ 	}
+ 	else
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 				 errmsg("Invalid PARTITION type specified")));
+ }
+ 
+ /*
+  * ------------------------------------------------------------------------------
+  * ValidateRanges : Check for the intersecting ranges of specified partitions.
+  * 
+  * ------------------------------------------------------------------------------
+  */
+ int ValidateRanges(PartitionAttrs *partAttr, Oid parentRelOid, Oid *partitionRelOids)
+ {
+ 	List			*partitionList;
+ 	List			*partitionColumnList;
+ 	ListCell		*p1;
+ 	ListCell		*p2;
+ 	Partition		*partition1, *partition2;
+ 	ListCell		*partitionColumn;
+ 	ListCell		*p1MinIndex, *p1MaxIndex, *p2MinIndex, *p2MaxIndex;
+ 	Datum			p1MinDatum, p1MaxDatum, p2MinDatum;
+ 	int				i, j, k;
+ 	Oid				typ_oid;
+ 	RegProcedure	procLessThan, procGreaterThan;
+ 	Oid				LessThanOid, GreaterThanOid;
+ 	bool			isDef;
+ 	bool			isP1MinValue, isP1MaxValue, isP2MinValue;
+ 	bool 			tmp1, tmp2;
+ 
+ 	i = 0;
+ 
+ 	/* Get the partition List. */
+ 	partitionList = partAttr->partitions;
+ 
+ 	/* Get the partition-key column list*/
+ 	partitionColumnList = partAttr->colName;
+ 
+ 	foreach(partitionColumn, partitionColumnList)
+ 	{		
+ 		char *colName = ((Alias *)lfirst(partitionColumn))->aliasname;
+ 		/* Get the column type. */
+ 		typ_oid = get_atttype(parentRelOid, get_attnum(parentRelOid, colName));
+ 
+ 		foreach(p1, partitionList)
+ 		{
+ 			partition1 = lfirst(p1);
+ 			j = 0;			
+ 			p1MinIndex = partition1->partitionCheck->min_value->head;
+ 			p1MaxIndex = partition1->partitionCheck->max_value->head;
+ 
+ 			while(j < i)
+ 			{
+     	        p1MinIndex = p1MinIndex->next;
+    	    	    p1MaxIndex = p1MaxIndex->next;
+ 				j++;
+ 			}
+ 
+ 			isP1MinValue = IsMinValue((Node *)lfirst(p1MinIndex));
+ 
+ 			if(isP1MinValue == false)
+ 			{	
+ 	   	        /* If it's a FuncExpr then execute the conversion function. */
+     	   	    if IsA((Node *)lfirst(p1MinIndex), FuncExpr)
+         	   	{
+             	   	p1MinDatum = OidFunctionCall1(((FuncExpr *)lfirst(p1MinIndex))->funcid,
+                 	   	            ((Const *)((FuncExpr *)lfirst(p1MinIndex))->args->head->data.ptr_value)->constvalue);
+ 	            }
+    		        else
+        		    {
+            		    p1MinDatum = ((Const *)lfirst(p1MinIndex))->constvalue;
+             	}
+ 			}
+ 
+ 			isP1MaxValue = IsMaxValue((Node *)lfirst(p1MaxIndex));
+ 
+ 			if(isP1MaxValue == false)
+ 			{
+ 
+ 	           /* If it's a FuncExpr then execute the conversion function. */
+    		        if IsA((Node *)lfirst(p1MaxIndex), FuncExpr)
+        		    {
+             	   	p1MaxDatum = OidFunctionCall1(((FuncExpr *)lfirst(p1MaxIndex))->funcid,
+            	    	                ((Const *)((FuncExpr *)lfirst(p1MaxIndex))->args->head->data.ptr_value)->constvalue);
+ 	       	    }
+    		        else
+         	    {
+            		    p1MaxDatum = ((Const *)lfirst(p1MaxIndex))->constvalue;
+ 				}
+        	    }
+ 
+ 			foreach(p2, partitionList)
+ 			{
+ 				if(p1 != p2)
+ 				{
+ 					partition2 = lfirst(p2);
+ 					k = 0;
+ 	                p2MinIndex = partition2->partitionCheck->min_value->head;
+         	        p2MaxIndex = partition2->partitionCheck->max_value->head;
+ 
+ 					while(k < i)
+ 					{
+                 	    p2MinIndex = p2MinIndex->next;
+             	        p2MaxIndex = p2MaxIndex->next;
+ 						k++;
+ 					}
+ 		
+ 					isP2MinValue = IsMinValue((Node *)lfirst(p2MinIndex));
+ 
+ 					if(isP2MinValue == false)
+ 					{
+ 			            /* If it's a FuncExpr then execute the conversion function. */
+ 		            	if IsA((Node *)lfirst(p2MinIndex), FuncExpr)
+     		    	    {
+         			        p2MinDatum = OidFunctionCall1(((FuncExpr *)lfirst(p2MinIndex))->funcid,
+     	        		                    ((Const *)((FuncExpr *)lfirst(p2MinIndex))->args->head->data.ptr_value)->constvalue);
+ 		            	}
+ 	    	        	else
+     	    		    {
+         		    	    p2MinDatum = ((Const *)lfirst(p2MinIndex))->constvalue;
+ 		    	        }
+ 					}
+ 
+ 	                tmp1 = true;
+     	            tmp2 = true;
+ 
+ 					if((isP1MinValue == false) && (isP2MinValue == false))
+ 					{
+ 			            LessThanOid = OperatorGet("<=", PG_CATALOG_NAMESPACE , typ_oid, typ_oid, &isDef);		
+ 
+ 		        	    if(isDef == FALSE)
+     			            elog(ERROR, "'<=' operator is not defined for type '%d'.", typ_oid);
+ 
+ 						procLessThan = get_opcode(LessThanOid);
+ 						tmp1 = DatumGetBool(OidFunctionCall2(procLessThan, p1MinDatum, p2MinDatum));
+ 					}
+ 					else if(isP1MinValue == true && isP2MinValue == false )
+ 					{
+ 						tmp1 = true;
+ 					}
+ 					else if(isP2MinValue == true && isP1MinValue == false)
+ 					{
+ 						tmp1 = false;
+ 					}
+ 
+ 
+ 					if((isP1MaxValue == false) && (isP2MinValue == false))	            	
+ 					{
+ 						GreaterThanOid = OperatorGet(">", PG_CATALOG_NAMESPACE , typ_oid, typ_oid, &isDef);
+ 	        	    
+ 						if(isDef == FALSE)
+     			            elog(ERROR, "'>' operator is not defined for type '%d'.", typ_oid);
+ 
+     	    	    	procGreaterThan = get_opcode(GreaterThanOid);
+ 						tmp2 = DatumGetBool(OidFunctionCall2(procGreaterThan, p1MaxDatum, p2MinDatum));
+ 					}
+ 					else if(isP1MaxValue == true)
+ 					{
+ 						tmp2 = true;
+ 					}
+ 					else if(isP2MinValue == true && isP1MinValue == false)
+ 					{
+ 						tmp2 = false;
+ 					}
+ 
+ 	    	        if(tmp1 == true && tmp2 == true )
+ 	            	{
+ 							elog(ERROR, "Partition ranges of '%s' and '%s' are overlapping for '%s' attribute.", 
+ 									partition1->partName->relname, partition2->partName->relname, colName);
+ 					}
+ 				}
+ 			}
+ 		}
+ 		i++;
+ 	}
+ 	return 0;
+ }
+ 
+ void 
+ AddLessThanCheckConstraint(Oid typ_oid, Datum max_datum, char *tableName, char *partitionColumn)
+ {
+ 	char		*expr_string;
+ 	Oid			typoutput;
+ 	bool		isVariableLength;
+ 	StringInfo	constraint = makeStringInfo();
+ 	List		*query_list;
+ 	Node		*parsetree;
+ 
+ 	getTypeOutputInfo(typ_oid, &typoutput, &isVariableLength);
+ 	expr_string = DatumGetCString(OidFunctionCall1(typoutput, max_datum));
+ 
+ 	/* Form the check constraint for child table. */
+ 	appendStringInfo(constraint, "ALTER TABLE %s ADD CHECK ( %s < '%s'); ",
+ 		tableName,
+ 		partitionColumn,
+ 		expr_string);
+ 
+ 	/* Parse the above SQL string and use this parsetree to create check constraint on child tables. */
+ 	query_list  = pg_parse_query(constraint->data);
+ 	parsetree = (Node *)lfirst(list_head(query_list));
+ 	AlterTable(( AlterTableStmt * )parsetree);
+ }
+ 
+ void 
+ AddGreaterThanCheckConstraint(Oid typ_oid, Datum min_datum, char *tableName, char *partitionColumn)
+ {
+ 	char		*expr_string;
+ 	Oid			typoutput;
+ 	bool		isVariableLength;
+ 	StringInfo	constraint = makeStringInfo();
+ 	List		*query_list;
+ 	Node		*parsetree;
+ 
+ 	getTypeOutputInfo(typ_oid, &typoutput, &isVariableLength);
+ 	expr_string = DatumGetCString(OidFunctionCall1(typoutput, min_datum));
+ 
+ 	/* Form the check constraint for child table. */
+ 	appendStringInfo(constraint, "ALTER TABLE %s ADD CHECK ( %s > '%s'); ",
+ 		tableName,
+ 		partitionColumn,
+ 		expr_string);
+ 
+ 	/* Parse the above SQL string and use this parsetree to create check constraint on child tables. */
+ 	query_list  = pg_parse_query(constraint->data);
+ 	parsetree = (Node *)lfirst(list_head(query_list));
+ 	AlterTable(( AlterTableStmt * )parsetree);
+ }
+ 
+ 
+ /*
+  * ------------------------------------------------------------------------------
+  * CreatePartitions : Add constraints on child tables as per ranges specified.
+  * Add the metadata to partition catalog table.
+  * ------------------------------------------------------------------------------
+  */
+ 
+ static void 
+ CreatePartitions(CreateStmt *stmt, Oid parentRelOid, Oid *partitionRelOids)
+ {
+ 	int				counter, numberOfPartitions;
+ 	PartitionAttrs	*partAttr;
+ 	char            *partitionColumn; 
+ 	StringInfo		func_insert = makeStringInfo();
+ 	StringInfo		func_update = makeStringInfo();
+     Partition   	*temp_partition;
+ 	List            *partitionList;
+ 	ListCell        *temp_part;
+ 	int 			partitionColumnType;
+ 	List			*partColumnList;
+ 	ListCell		*partColumn;
+ 	int 			count, i, j, l;
+ 	List			*columnList;
+ 	ListCell		*column;
+ 	int 			*partKeyOrder;
+ 	int				partitionNumber;
+ 	int				rangeVal;
+ 
+ 	partAttr = (PartitionAttrs *)(stmt->partAttr);
+ 
+     if(partAttr->partFunc == PART_HASH)
+     {
+         return ;
+     }
+ 
+     /* Reset the buffers used.  */
+     resetStringInfo(func_insert);
+     resetStringInfo(func_update);
+ 
+ 	/* Reset */
+ 	counter 			= 0;
+ 	numberOfPartitions 	= 0;
+ 	i					= 0;
+ 	j					= 0;
+ 	l					= 0;
+ 	partitionNumber		= 0;
+ 	
+ 	partitionList = partAttr->partitions;
+ 	numberOfPartitions = list_length(partitionList);
+ 	Assert(numberOfPartitions);
+ 
+ 	/* Get the list of partition key columns. */
+ 	partColumnList = partAttr->colName;
+ 
+ 	partKeyOrder = malloc(partColumnList->length * sizeof(int));
+ 
+ 	columnList 	= stmt->tableElts;
+ 
+ 	foreach(partColumn, partColumnList)
+ 	{
+ 		/* Get the name of partition key column. */
+ 		char 	*colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 		bool 	found = false;
+ 		count = 0;
+ 
+ 		foreach(column, columnList)
+ 		{
+ 			ColumnDef *tmp = lfirst(column);
+ 			count++;
+ 			if(strcmp(tmp->colname, colName) == 0)
+ 			{
+ 				partKeyOrder[j++] = count;
+ 				found = true;
+ 				break;
+ 			}
+ 		}
+ 
+ 		if(found == false)
+ 			elog(ERROR, "'%s' attribute is not present in given table.", colName);
+ 
+ 	}
+ 
+ 	foreach(temp_part, partitionList)
+ 	{
+ 		ListCell 	*minIndex, *maxIndex;
+ 
+ 		temp_partition = lfirst(temp_part);
+ 
+ 		if ( partAttr->partFunc == PART_RANGE )
+ 		{
+ 			minIndex = temp_partition->partitionCheck->min_value->head;
+ 			maxIndex = temp_partition->partitionCheck->max_value->head;
+ 		}
+ 
+ 		partitionNumber++;
+ 
+ 		j = 0;
+ 	
+ 		foreach(partColumn, partColumnList)
+ 		{
+ 
+ 			/* Get the name of partition key column. */
+ 			char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 			partitionColumn = colName;
+ 	
+ 			/* Type of partition key column */
+     		partitionColumnType = get_atttype(parentRelOid, get_attnum(parentRelOid, partitionColumn)); 
+ 
+ 	        if ( partAttr->partFunc == PART_LIST )
+ 			{
+ 				elog(ERROR, "List partitions are not yet supported.");
+ 			}
+ 			else
+ 			{		
+ 				Datum 			min_datum, max_datum;
+ 				Oid 			typ_oid;
+ 				bool 			typbyval;
+ 				int16			len;
+ 			
+ 				/* Get the attribute type. */
+ 				typ_oid = get_atttype(parentRelOid, get_attnum(parentRelOid, partitionColumn));
+ 	
+ 				IsValidRange(minIndex, maxIndex, parentRelOid, partitionColumn, temp_partition->partName->relname);	
+ 
+ 				if(IsA(lfirst(minIndex), ColumnRef))
+ 				{
+ 					ColumnRef	*colRef = lfirst(minIndex);		
+ 		
+ 					if(list_length(colRef->fields) == 1)
+ 					{
+ 						if(strcmp(((Alias *)linitial(colRef->fields))->aliasname, "minvalue") == 0)
+ 						{
+ 							rangeVal = MINVALRANGE;
+ 							AddLessThanCheckConstraint(typ_oid, 
+ 								((Const *)lfirst(maxIndex))->constvalue, 
+ 								 temp_partition->partName->relname, 
+ 								partitionColumn);	
+ 						}
+ 						else
+ 						{
+ 							elog(ERROR, "Not a valid value.");
+ 						}
+ 					}
+ 				} 
+ 				else if(IsA(lfirst(maxIndex), ColumnRef))
+ 				{
+ 					ColumnRef	*colRef = lfirst(maxIndex);		
+ 		
+ 					if(list_length(colRef->fields) == 1)
+ 					{
+ 						if(strcmp(((Alias *)linitial(colRef->fields))->aliasname, "maxvalue") == 0)
+ 						{
+ 							rangeVal = MAXVALRANGE;
+ 							AddGreaterThanCheckConstraint(typ_oid, 
+ 								((Const *)lfirst(minIndex))->constvalue, 
+ 								 temp_partition->partName->relname, 
+ 								partitionColumn);	
+ 						}
+ 						else
+ 						{
+ 							elog(ERROR, "Not a valid value.");
+ 						}
+ 					}
+ 				}
+ 				else
+ 				{
+ 					rangeVal = OTHER;
+ 					AddCheckConstraint(typ_oid, 
+ 						((Const *)lfirst(minIndex))->constvalue, 
+ 						((Const *)lfirst(maxIndex))->constvalue, 
+ 						 temp_partition->partName->relname, 
+ 						partitionColumn);	
+ 				}
+ 
+ 				/* Get the attribute length*/
+ 				get_typlenbyval(typ_oid, &len, &typbyval);
+ 
+ 				min_datum = ((Const *)lfirst(minIndex))->constvalue;
+ 				max_datum = ((Const *)lfirst(maxIndex))->constvalue;
+ 
+ 				minIndex = minIndex->next;
+ 				maxIndex = maxIndex->next;
+ 
+ 		        WriteRangePartitionToCatalog(min_datum,
+     		                                    max_datum,
+         		                                len,
+             		                            typbyval,
+                 		                        parentRelOid,
+                     		                    partitionRelOids[l],
+                         		                get_attnum(parentRelOid, partitionColumn),
+                             		            typ_oid,
+                                 		        ++j,
+ 												rangeVal);
+ 
+ 			}	
+ 		}
+ 		l = l + 1;
+ 	}
+ 	if ( partAttr->partFunc == PART_RANGE )
+ 		ValidateRanges(partAttr,parentRelOid, partitionRelOids);
+ 	return;
+ }
+ 
+ /*
+  * Pass either "*OLD*" or "*NEW*" as appropriate depending on the trigger to
+  * to be generated
+  */
+ static void 
+ MutateColumnRefs(Node *node, char *reference) 
+ {
+ 	if IsA(node, A_Expr) 
+ 	{
+ 		MutateColumnRefs( ((A_Expr *) node)->lexpr, reference );
+ 		MutateColumnRefs( ((A_Expr *) node)->rexpr, reference);
+ 	} 
+ 	else if IsA(node, ColumnRef) 
+ 	{
+ 		ColumnRef *col_ref = (ColumnRef *) node;
+ 
+ 		/* Should have at max one column in the column list */
+ 		Assert(1 == list_length(col_ref->fields));
+ 		
+ 		col_ref->fields = list_make2(makeString(reference),
+ 								lfirst(list_head(col_ref->fields)));
+ 
+ 	}
+ 	return;
  }
